;DEBUG	=	1
;ALTBOOT =	1

.DEFINE EQU	=
.DEFINE DB	.BYTE
.DEFINE DW	.WORD
.DEFINE PAGE	.ALIGN 256
.DEFINE ORG	.ORG
	.CODE
;*
;* ACIA REGISTERS
;*
ACIADR	EQU	$C088
ACIASR	EQU	$C089
ACIACR	EQU	$C08A
ACIAMR	EQU	$C08B
;*
;* APPLE I/O LOCATIONS
;*
INDCTR	EQU	$0400
MSGLN	EQU	$07D0
KEYBD	EQU	$C000
STROBE	EQU	$C010
XROMOFF	EQU	$CFFF
ROMEN	EQU	$C082
;*
;* DRIVER SCRATCHSCRTCH
;*
SCRTCH0	EQU	$0478
SCRTCH1	EQU	$04F8		; SYNCED FLAG
SCRTCH2	EQU	$0578
SCRTCH3	EQU	$05F8
SCRTCH4	EQU	$0678
SCRTCH5	EQU	$06F8
SCRTCH6	EQU	$0778
SCRTCH7	EQU	$07F8
CMDACK	EQU	SCRTCH0
SYNCED	EQU	SCRTCH1
SAVE16	EQU	SCRTCH2
IOSLOT	EQU	$07F8		; CURRENT SLOT FOR IRQ HANDLING
;*
;* UTIL ROUTINES
;*
.IFDEF	DEBUG
MONITOR	EQU	$FF69
.ENDIF
;*
;* ZERO PAGE PARAMETERS
;*
SLOT16	EQU	$3C
PDCMD	EQU	$42
PDUNIT	EQU	$43
PDBUFF	EQU	$44
PDBUFL	EQU	$44
PDBUFH	EQU	$45
PDBLKL	EQU	$46
PDBLKH	EQU	$47
;*
;* PRODOS COMMANDS
;*
PDSTAT	EQU	0
PDREAD	EQU	1
PDWRITE	EQU	2
PDFORMT	EQU	3
;*
;* PIDRIVE ALTERNATE READ COMMAND
;*
PIBOOT	EQU	4+PDREAD
;*
;* PRODOS ERRORS
;*
PDNOERR	EQU	$00
PDIOERR	EQU	$27
PDNODEV	EQU	$28
PDWRPRT	EQU	$2B
;*
;* PIDRIVE SYNC and SYNC_ACK
;*
SYNC_REQ EQU	$80
SYNC_ACK EQU	$81
